opal/mca/paffinity/linux/paffinity_linux.h File Reference.TH "opal/mca/paffinity/linux/paffinity_linux.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
opal/mca/paffinity/linux/paffinity_linux.h \- Processor affinity for Linux. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'opal/mca/mca.h'\fP
.br
\fC#include 'opal/mca/paffinity/paffinity.h'\fP
.br
\fC#include <string.h>\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBOMPI_CPU_ZERO\fP(foo)   memset(foo, 0, sizeof(*foo))"
.br
.RI "\fIDetermine whether we have a working CPU_ZERO() macro or not. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "const \fBopal_paffinity_base_module_1_0_0_t\fP * \fBopal_paffinity_linux_component_query\fP (int *query)"
.br
.RI "\fIpaffinity query API function \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "OMPI_COMP_EXPORT const \fBopal_paffinity_base_component_1_0_0_t\fP \fBmca_paffinity_linux_component\fP"
.br
.RI "\fIGlobally exported variable. \fP"
.in -1c
.SH "Detailed Description"
.PP 
Processor affinity for Linux. 

Linux sucks. There are at least 3 different ways that sched_setaffinity is implemented (only one of which -- the most outdated -- is documented in the sched_setaffinity(2) man page):
.PP
----------------------------------------------------------------- 1. int sched_setaffinity(pid_t pid, unsigned int len, unsigned long *mask);
.PP
This originated in 2.5 kernels (which we won't worry about) and some distros back-ported it to their 2.4 kernels. It's unknown if this appears in any 2.6 kernels.
.PP
2. int sched_setaffinity (pid_t __pid, size_t __cpusetsize, const cpu_set_t *__cpuset);
.PP
This appears to be in recent 2.6 kernels (confirmed in Gentoo 2.6.11). I don't know when #1 changed into #2. However, this prototype is nice -- the cpu_set_t type is accompanied by fdset-like CPU_ZERO(), CPU_SET(), CPU_ISSET(), etc. macros.
.PP
3. int sched_setaffinity (pid_t __pid, const cpu_set_t *__mask);
.PP
(note the missing len parameter) This is in at least some Linux distros (e.g., MDK 10.0 with a 2.6.3 kernel, and SGI Altix, even though the Altix uses a 2.4-based kernel and therefore likely back-ported the 2.5 work but modified it for their needs). Similar to #2, the cpu_set_t type is accompanied by fdset-like CPU_ZERO(), CPU_SET(), CPU_ISSET(), etc. macros. -----------------------------------------------------------------
.PP
This component has to figure out which one to use. :-\\
.PP
Also note that at least some distros of Linux have a broken CPU_ZERO macro (a pair of typos in /usr/include/bits/sched.h). MDK 9.2 is the screaming example, but it's pretty old and probably only matters because one of the developers uses that as a compilation machine :-) (it also appears to have been fixed in MDK 10.0, but they also changed from #2 to #3 -- arrgh!). However, there's no way of knowing where these typos came from and if they exist elsewhere. So it seems safest to extend this configure script to check for a bad CPU_ZERO macro. #$#%$@!!!
.SH "Define Documentation"
.PP 
.SS "#define OMPI_CPU_ZERO(foo)   memset(foo, 0, sizeof(*foo))"
.PP
Determine whether we have a working CPU_ZERO() macro or not. 
.PP
If not, use memset(). 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
